- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.WireGroupList.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/wireGroups/list#try-it)

Lists the wire groups for a project in the given scope.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/beta/projects/{project}/global/crossSiteNetworks/{crossSiteNetwork}/wireGroups`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `crossSiteNetwork` | `string` |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |

### Request body

The request body must be empty.

### Response body

Response for the list request.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": [ { "kind": string, "selfLink": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "endpoints": { string: { "interconnects": { string: { "interconnect": string, "vlanTags": [ integer ] }, ... } }, ... }, "wireGroupProperties": { "type": enum }, "wireProperties": { "bandwidthUnmetered": string, "bandwidthAllocation": enum, "faultResponse": enum }, "adminEnabled": boolean, "wires": [ { "label": string, "endpoints": [ { "interconnect": string, "vlanTag": integer } ], "wireProperties": { "bandwidthUnmetered": string, "bandwidthAllocation": enum, "faultResponse": enum }, "adminEnabled": boolean } ], "topology": { "endpoints": [ { "label": string, "city": string } ] }, "reconciling": boolean } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] }, "etag": string, "unreachables": [ string ] } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#wireGroups` for wire groups. |
| `id` | `string` Output only. Unique identifier for the resource; defined by the server. |
| `items[]` | `object` A list of wire group resources. |
| `items[].kind` | `string` Output only. Type of the resource. Always `compute#wireGroups` for wire groups. |
| `items[].selfLink` | `string` Output only. Server-defined URL for the resource. |
| `items[].id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource type. The server generates this identifier. |
| `items[].creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `items[].name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `items[].description` | `string` An optional description of the wire group. |
| `items[].endpoints[]` | `map (key: string, value: object)` A map that contains the logical endpoints of the wire group. Specify key-value pairs for the map as follows: - Key: an RFC1035 user-specified label. - Value: an `Endpoint` object. <br /> |
| `items[].endpoints[].interconnects[]` | `map (key: string, value: object)` A map that contains the redundant Interconnect connections. Specify key-value pairs for the map as follows: - Key: an RFC1035 user-specified label. - Value: an `Interconnect` object. <br /> |
| `items[].endpoints[].interconnects[].interconnect` | `string` Required. An Interconnect connection. You can specify the connection as a partial or full URL. If the connection is in a different project from the cross-site network, use a format that specifies the project. See the following examples of partial and full URLs: `global/interconnects/NAME` `projects/PROJECT_ID/global/interconnects/NAME` - `https://compute.googleapis.com/compute/projects/PROJECT_ID/global/interconnects/NAME` <br /> |
| `items[].endpoints[].interconnects[].vlanTags[]` | `integer` Required. To configure the wire group for VLAN mode, enter a VLAN tag, which is a number from `2` to `4093`. You can autoallocate a tag by entering `0`. To configure the wire group for port mode, enter `-1`. Review the following guidelines: - A VLAN tag must be unique for an Interconnect connection across all attachments and wire groups. - Both endpoints of a wire must use the same VLAN tag value. - Single wire and redundant type wire groups must have only one VLAN tag. - Port mode pseudowires must have a single VLAN tag with a value of `-1` for both endpoints. - Box and cross type wire groups must have two VLAN tags. The first is for the same-zone pseudowire, and the second is for the cross-zone pseudowire. <br /> |
| `items[].wireGroupProperties` | `object` Properties of the wire group. |
| `items[].wireGroupProperties.type` | `enum` The type of the wire group, one of the following: - WIRE: a single pseudowire over two Interconnect connections with no redundancy. - REDUNDANT: two pseudowires over four Interconnect connections, with two connections in one metro and two connections in another metro. Each redundant pair of Interconnect connections spans both edge availability domains of the metro. Each pseudowire connects Interconnect connections in matching edge availability domains of the two metros. - BOX_AND_CROSS: four pseudowires over four Interconnect connections, with two connections in one metro and two connections in another metro. Each redundant pair of Interconnect connections spans both edge availability domains of the metro. Two pseudowires connect Interconnect connections in matching edge availability domains of the two metros. Two additional pseudowires connect the non-matching edge availability domains of the two metros. <br /> |
| `items[].wireProperties` | `object` Properties for all wires in the wire group. |
| `items[].wireProperties.bandwidthUnmetered` | `string (https://developers.google.com/discovery/v1/type-format format)` The unmetered bandwidth in Gigabits per second, using decimal units. `10` is 10 Gbps, `100` is 100 Gbps. The bandwidth must be greater than 0. |
| `items[].wireProperties.bandwidthAllocation` | `enum` The configuration of the bandwidth allocation, one of the following: - ALLOCATE_PER_WIRE: configures a separate unmetered bandwidth allocation (and associated charges) for each wire in the group. - SHARED_WITH_WIRE_GROUP: this is the default behavior, which configures one unmetered bandwidth allocation for the wire group. The unmetered bandwidth is divided equally across each wire in the group, but dynamic throttling reallocates unused unmetered bandwidth from unused or underused wires to other wires in the group. <br /> |
| `items[].wireProperties.faultResponse` | `enum` Response when a fault is detected in a pseudowire: - NONE: default. - DISABLE_PORT: set the port line protocol down when inline probes detect a fault. This setting is only permitted on port mode pseudowires. <br /> |
| `items[].adminEnabled` | `boolean` Indicates whether the wires in the wire group are enabled. When false, the wires in the wire group are disabled. When true and when there is simultaneously no wire-specific override of `adminEnabled` to false, a given wire is enabled. Defaults to true. |
| `items[].wires[]` | `object` Output only. The single/redundant wire(s) managed by the wire group. |
| `items[].wires[].label` | `string` Output only. A label that identifies the wire. The format of this label combines the existing labels of the wire group endpoints and Interconnect connections used by this wire in alphabetical order as follows: `ENDPOINT_A+CONNECTION_A1,ENDPOINT_B+CONNECTION_B1`, where: - `ENDPOINT_A` and `ENDPOINT_B`: are the labels that you entered as map keys when you specified the wire group endpoint objects. - `CONNECTION_A1` and `CONNECTION_B1`: are the labels that you entered as map keys when you specified the wire group Interconnect objects. <br /> |
| `items[].wires[].endpoints[]` | `object` Output only. Wire endpoints are specific Interconnect connections. |
| `items[].wires[].endpoints[].interconnect` | `string` |
| `items[].wires[].endpoints[].vlanTag` | `integer` |
| `items[].wires[].wireProperties` | `object` Output only. Properties of the wire. |
| `items[].wires[].wireProperties.bandwidthUnmetered` | `string (https://developers.google.com/discovery/v1/type-format format)` The unmetered bandwidth in Gigabits per second, using decimal units. `10` is 10 Gbps, `100` is 100 Gbps. The bandwidth must be greater than 0. |
| `items[].wires[].wireProperties.bandwidthAllocation` | `enum` The configuration of the bandwidth allocation, one of the following: - ALLOCATE_PER_WIRE: configures a separate unmetered bandwidth allocation (and associated charges) for each wire in the group. - SHARED_WITH_WIRE_GROUP: this is the default behavior, which configures one unmetered bandwidth allocation for the wire group. The unmetered bandwidth is divided equally across each wire in the group, but dynamic throttling reallocates unused unmetered bandwidth from unused or underused wires to other wires in the group. <br /> |
| `items[].wires[].wireProperties.faultResponse` | `enum` Response when a fault is detected in a pseudowire: - NONE: default. - DISABLE_PORT: set the port line protocol down when inline probes detect a fault. This setting is only permitted on port mode pseudowires. <br /> |
| `items[].wires[].adminEnabled` | `boolean` Output only. Indicates whether the wire is enabled. When false, the wire is disabled. When true and when the wire group of the wire is also enabled, the wire is enabled. Defaults to true. |
| `items[].topology` | `object` Output only. Topology details for the wire group configuration. |
| `items[].topology.endpoints[]` | `object` Output only. Topology details for all endpoints in the wire group. |
| `items[].topology.endpoints[].label` | `string` Output only. Endpoint label from the wire group. |
| `items[].topology.endpoints[].city` | `string` Output only. The InterconnectLocation.city (metropolitan area designator) that all interconnects are located in. |
| `items[].reconciling` | `boolean` Output only. Indicates whether there are wire changes yet to be processed. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `etag` | `string` |
| `unreachables[]` | `string` Output only. Unreachable resources. end_interface: MixerListResponseWithEtagBuilder |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.wireGroups.list`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).